/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// This example is from the ACE Programmers Guide.
////  Chapter:  "Thread Management"
//// For details please see the guide at
//// http://www.cs.wustl.edu/~schmidt/ACE.html
////  AUTHOR: Umar Syyid (usyyid@hns.com)
//// and Ambreen Ilyas (ambreen@bitsmart.com)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Example 1
#include "ace/Thread.h"
#include "ace/OS.h"
#include "ace/Synch_T.h"
#include "ace/Synch.h"
static int number=0;
static int seed=0;

static void*
worker(void *arg){
 ACE_UNUSED_ARG(arg);
 ACE_DEBUG((LM_DEBUG,"Thread (%t) Created to do some work"));
 ::number++;
 ACE_DEBUG((LM_DEBUG," and number is %d\n",::number));
 
 //Let the other guy go while I fall asleep for a random period of time
 ACE_Thread::yield();
 ACE_OS::sleep(ACE_OS::rand()%2);

 //Exiting now
 ACE_DEBUG((LM_DEBUG,
   "\t\t Thread (%t) Done! \t The number is now: %d\n",number));
 ACE_OS::fflush(stdout);
 return 0;
 }
 

int main(int argc, char *argv[]){
if(argc<2) {
 ACE_DEBUG((LM_DEBUG,"Usage: <program_name> <number of threads>\n"));
 ACE_OS::exit(1);
}
 
int n_threads=ACE_OS::atoi(argv[1]);
//Number os threads to spawn

ACE_OS::srand(::seed);
//Setup the random number generator

ACE_thread_t *threadID= new ACE_thread_t[n_threads+1];
ACE_hthread_t *threadHandles = new ACE_hthread_t[n_threads+1];

if (ACE_Thread::spawn_n(threadID, n_threads, (ACE_THR_FUNC)worker, 0, THR_JOINABLE | THR_NEW_LWP,
			ACE_DEFAULT_THREAD_PRIORITY, 0, 0, threadHandles) == -1)
  ACE_DEBUG ((LM_DEBUG,"Error in spawning thread\n"));
// spawn n_threads
  

for (int i=0; i<n_threads; i++)
  ACE_Thread::join(threadHandles[i]);

//Wait for all threads to exit before you let the main fall through
//and have the process exit.

return 0;
} 
