/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// This example is from the ACE Programmers Guide.
////  Chapter:  "Thread Management"
//// For details please see the guide at
//// http://www.cs.wustl.edu/~schmidt/ACE.html
////  AUTHOR: Umar Syyid (usyyid@hns.com)
//// and Ambreen Ilyas (ambreen@bitsmart.com)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Example 8
#include "ace/Synch_T.h"
#include "ace/Synch.h"
#include "ace/Atomic_Op_T.h"

ACE_Atomic_Op<ACE_Thread_Mutex,int> foo;

static void*
worker(void *arg){
  ACE_UNUSED_ARG(arg);
  foo=5;
  ACE_ASSERT (foo == 5);
 
  ++foo;
  ACE_ASSERT (foo == 6);
 
  --foo;
  ACE_ASSERT (foo == 5);
 
  foo += 10;
  ACE_ASSERT (foo == 15);
 
  foo -= 10;
  ACE_ASSERT (foo == 5);
 
  foo = 5L;
  ACE_ASSERT (foo == 5);
 return 0;
}

int main(int argc, char *argv[]){
if(argc<2) {
 ACE_DEBUG((LM_DEBUG,"Usage: <program_name> <number of threads>\n"));
 ACE_OS::exit(1);
}
 
int n_threads=ACE_OS::atoi(argv[1]);
//Number os threads to spawn

ACE_thread_t *threadID= new ACE_thread_t[n_threads+1];
ACE_hthread_t *threadHandles = new ACE_hthread_t[n_threads+1];

if (ACE_Thread::spawn_n(threadID, n_threads, (ACE_THR_FUNC)worker, 0, THR_JOINABLE | THR_NEW_LWP,
			ACE_DEFAULT_THREAD_PRIORITY, 0, 0, threadHandles) == -1)
  ACE_DEBUG ((LM_DEBUG,"Error in spawning thread\n"));
// spawn n_threads
  

for (int i=0; i<n_threads; i++)
  ACE_Thread::join(threadHandles[i]);

//Wait for all threads to exit before you let the main fall through
//and have the process exit.

return 0;
} 
