#include "ace/Auto_Ptr.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Acceptor.h"
#include "ace/SOCK_Stream.h"
#include "ace/Mem_Map.h"
#include "ace/Auto_Ptr.h"

extern char *get_url_pathname (ACE_SOCK_Stream *);

int main ()
{
	ACE_INET_Addr server_addr;
	ACE_SOCK_Acceptor acceptor;
	ACE_SOCK_Stream *peer;

	if (server_addr.set (80) == -1) return 1;
	if (acceptor.open (server_addr) == -1) return 1;

	for (;;) {
		if (acceptor.accept (*peer) == -1) return 1;
		peer->disable (ACE_NONBLOCK);

		char *pathname = get_url_pathname (peer);
		ACE_Mem_Map mapped_file (pathname);

		if (peer->send_n (mapped_file.addr (), mapped_file.size ()) == -1)
			return 1;
		peer->close ();
	}

	return acceptor.close () == -1 ? 1 : 0;
}
